<?php
/**
 * IGBClass 2 Example -- PHP4
 * 	(c) 2003-2004 Nonsequitur (Patrick D Hall) Nonsequitur SoftWerx.
 *  
 *	IGBDemo v2, for EVE-Online: Exodus (CCP)
 *
 *  This simple script should give you a decent idea on how to implement
 *  the igbclass_v2.php class in your existing php4+ IGB sites.  The
 *  example provided is a bare mininimum but should show how ID's can be in-
 *  corporated to show info, and generate images with the new features of the
 *  IGB. There are many more things you can do in the IGB since Exodus, with
 *  regards to the improved HTML support, and CSS features added. This demo
 *  demonstrates but a handful, of css and table support now present.
 *  
 *  The IGBClass was designed to plug in to existing IGB sites with little,
 *  and in most cases no, conflicts.  Excluding the case where IGB
 *  is already used in the existing namespace.  In that case it would be trivial
 *  to rename the class in igbclass_v2.php and the instance creation below to
 *  fit the needs of your IGB website.
 *
 *  v2 of this demo steps beyond the simple html code in the first igbexample
 *  code to show the better formatting and html/css support now present with the
 *  newer versions of the IGB.  This code also changes the style to use more of
 *  an escape to php approach, versus the old php only approach to coding. It
 *  was just easier for me to build it more like a template page with php used
 *  to fill in the areas that are dynamic.
 *
 *
 *  ***************************************************************************
 *  This code is provided Freely for any, and all use you the end user
 *  would like to use it for.  This project started as my first PHP
 *  "Hello World" script back in EVE Beta 6, when I decided to tinker with
 *  the IGB.  Both this script, and the IGB itself have come a long way
 *  since then.  Since this code is provided Free for any use, the only thing
 *  I ask of you, the end user, is just to drop me a line and let me know
 *  what you think, or maybe what you are working on.  Just fire off an email
 *  to the address below, make sure to substitute the proper symbols in place
 *  of the [Spam] hacks.  And good luck with your IGB projects. *
 *  ***************************************************************************
 *  Questions, Bugs, comments?
 *      	send em here - pdhall[AT]gmail[DOT]com   <-- despam and send
 *  
*/

// start buffered output (needed to ensure all headers are sent before html output)
ob_start();

// include the igbclass code
require_once("igbclass_v2.php");


// check if the visitor would like to emulate a different predefined user for this visit
// by looking for ?emulate at the end of the url.  A word of caution, do not release
// your own final igb site with such a blatant security risk.  In this demo it doesn't
// matter what the user is, as it is only displayed back to him and not acted upon for
// any other purpose.
if (isset($_GET['emulate'])){	
	// Create Instance of Class IGB in emulation mode
	$TestUser['HTTP_EVE_TRUSTED']				= 'yes';
	$TestUser['HTTP_EVE_CHARID']				= '243025575';
	$TestUser['HTTP_EVE_CHARNAME']				= 'Joe IGB';
	$TestUser['HTTP_EVE_CORPNAME']				= 'University of Caille';
	$TestUser['HTTP_EVE_CORPID']				= '1000115';
    $TestUser['HTTP_EVE_ALLIANCENAME']			= 'None';
    $TestUser['HTTP_EVE_ALLIANCEID']			= 'None';
    $TestUser['HTTP_EVE_CORPROLE']				= '36028797018963841';
    $TestUser['HTTP_EVE_STATIONNAME']			= 'None';
    $TestUser['HTTP_EVE_SOLARSYSTEMNAME']		= 'Bourynes';
    $TestUser['HTTP_EVE_CONSTELLATIONNAME']		= 'Nexus';
    $TestUser['HTTP_EVE_REGIONNAME']			= 'Sinq Laison';
    $TestUser['HTTP_USER_AGENT']				= 'EVE-minibrowser/3.0';
    $TestUser['REMOTE_ADDR']					= '127.0.0.1';
    $TestUser['HTTP_EVE_SERVERIP']				= '212.187.162.10:26000';
	
	// create instance of emulated user
	$IGBUser = new IGB($TestUser);
} else {
	// create instance of normal user
	$IGBUser = new IGB();
}

// we can always send this header, if trust is enabled then it is ignored by the browser.
$IGBUser->RequestTrust("For the IGBClass demo to show you must enable trust in your In-Game-Browser.");

// test that the visitor is in the IGB and not just emulating IGB
// since standard browsers look bad when viewing this page's CSS
if ((!$IGBUser->IsMiniBrowser()) || ($IGBUser->BrowserAgent != $_SERVER['HTTP_USER_AGENT'])) {
	// warn about non IGB browsers and exit script
	echo "This page only displays the formatting properly in the IGB. Try this from your IGB in EVE instead.";
	die;
}

// check for browser trust (normal or emulated supported internally
if ($IGBUser->IsTrustEnabled()) {

// while inside the TrustEnabled section we escape out of php and into html
// for a more template like approach to document creation.
?>
<html>
	<head>
		<!-- Include our Style Sheet used to make the page pretty -->
		<LINK REL="stylesheet" TYPE="text/css" HREF="igbdemo.css">
		<title><?php echo "IGBDemo v".CLASS_VER; ?></title>
	</head>
	
	<body>
		<center>
		
		<!-- Navigation Bar -->
		<table width="550">
			<tr>
				<td class="navhdr">
				<?php
					// check if we are emulated or not
					if ($IGBUser->IsEmulated()) {
						// display emulation mode header
						echo ":: IGBClass User Emulation Demo ::";
					} else {
						// display standard mode header
						echo ":: IGBClass User Demo ::";
					}
				?></td>
			</tr>
			<tr>
				
				<td class="navbarlinks" >
				<!-- Show Reload normal view -->
				<?php echo "[ <a href=\"http://".$_SERVER['HTTP_HOST'].$_SERVER['SCRIPT_NAME']."\">Reload Normal</a> ]"; ?>
				<!-- Show Reload Emulated view -->
				<?php echo "[ <a href=\"http://".$_SERVER['HTTP_HOST'].$_SERVER['SCRIPT_NAME']."?emulate\">Reload Emulated</a> ]"; ?>
				</td>
			</tr>			
		</table>
		<br>		
		
		<!-- Character General -->
		<table style="border: 1px;" cellspacing="0" width="550">
						
			<!-- Start character details -->
			<tr>
				<td class="infohdr" colspan="3">Character Details</td>
			</tr>
			
			
			<!-- Character -->
			<tr>
				<!-- portrait generation using portrait and showinfo combo -->
				<td class="ccell" width="136" rowspan="7"><a href="showinfo:1//<?php echo $IGBUser->UserID();?>"><img class="cimg" src="portrait:<?php echo $IGBUser->UserID();?>" width="128" height="128" alt="Click for info"></a></td>
				
				<!-- name details with showinfo feature -->
				<td class="infolbl" width="120">Character Name</td>					
				<td class="infodata">
					<a href="showinfo:1//<?php echo $IGBUser->UserID();?>" alt="Click for info"><?php echo $IGBUser->UserName();?></a>
				</td>
			
			</tr>
			
			<!-- Corporation with showinfo details -->
			<tr>
				<td class="infolbl">Corporation Name</td>
				<td class="infodata"><a href="showinfo:2//<?php echo $IGBUser->UserCorpID();?>" alt="Click for info"><?php echo $IGBUser->UserCorp();?></a></td>
			</tr>
			
			<!-- Alliance with showinfo details -->
			<tr>
				<td class="infolbl">Alliance Name</td>
				<td class="infodata"><?php
					// give us a showinfo link for an alliance if present
					if ($IGBUser->IsInAlliance()) {
						echo '<a href="showinfo:16159//'.$IGBUser->UserAllianceID().'" alt="Click for info">'.$IGBUser->UserAlliance().'</a>';
					} else {
						// show no info if alliance is 'None' 
						echo $IGBUser->UserAlliance();
					}
				?></td>
			</tr>
			
			<!-- Station name if docked at station, or 'None' if not in a station (ie, in space) -->
			<tr>
				<td class="infolbl" width="120">Station</td>					
				<td class="infodata"><?php echo $IGBUser->UserStation();?></td>
			</tr>
			
			<!-- Solarsystem name -->
			<tr>
				<td class="infolbl" width="120">Solarsystem</td>					
				<td class="infodata"><?php echo $IGBUser->UserSystem();?></td>
			</tr>
			
			<!-- Constellation name -->
			<tr>
				<td class="infolbl" width="120">Constellation</td>
				<td class="infodata"><?php echo $IGBUser->UserConstellation();?></td>
			</tr>
			
			<!-- Region name -->
			<tr>
				<td class="infolbl" width="120">Region</td>
				<td class="infodata"><?php echo $IGBUser->UserRegion();?></td>
			</tr>
		</table>
		<br>
		
		
		<!-- Dynamic Roles Table, displaying roles of viewer if any happen to be set -->
		<table style="border: 1px;" cellspacing="0" width="550">
			
			<!-- Start of Dynamic Rows based on granted roles -->
			<tr>
				<td class="infohdr" colspan="3">Corporation Roles</td>
			</tr>
			<?php
			// dynamically generate rows based on what roles visitor has set.
			if (!$IGBUser->UserRole()) {
				// user has no corp roles assigned, so we short circuit with a notice
				echo '<tr><td class="rolemarker" width="20"></td><td class="roledata" colspan="2">no corporation roles assigned</td></tr>'."\n";
			} else {
				// run though each catagory
				foreach ($role_zone as $zone_k => $zone_v) {
					$role_rows = "";
					
					// check each for roles and build the table rows
					foreach ($role as $role_k => $role_v) {
						// if the role fits the catagory and is set on the character create a chunk of rows to reflect this
						if (($role_v['rolezone'] == $zone_k) && ($IGBUser->HasRole($role_k))){
							$role_rows .= '<tr><td class="rolemarker" width="20" align="center"><a alt="'.$role_v['desc'].'">?</a></td><td class="roledata" colspan="2">'.$role_v['name']."</td></tr>\n";
						}
					}
					// if character had roles set in this catagory show them on the page
					if ($role_rows) {
						// show catagory heading
						echo '<tr><td class="rolediv" colspan="3">'.$zone_v['name'].'</td></tr>';
						// print rows in catagory
						echo $role_rows;
					}
					
				}			
			}
			?>			
		</table>
		<br>
		
		
		<!-- Generic IGB Data -->
		<table style="border: 1px;" cellspacing="0" width="550">			
			<tr>
				<td class="infohdr" colspan="2">General IGB Details</td>				
			</tr>
			<tr>
				<!-- IP address of the visitor -->
				<td class="infolbl" width="120">Client IP</td>
				<td class="infodata"><?php echo $IGBUser->UserIPAddress(); ?></td>
			</tr>
			<tr>
				<!-- IP address of game server the visitor is browsing from -->
				<td class="infolbl" width="120">Server IP</td>
				<td class="infodata"><?php echo $IGBUser->UserServerIP(); ?></td>
			</tr>
			<tr>
				<!-- User Agent of the visitor's browser -->
				<td class="infolbl" width="120">Browser Agent</td>
				<td class="infodata"><?php echo $IGBUser->BrowserAgent(); ?></td>
			</tr>
			<tr>
				<!-- Generic MD5 Hash generated from the IGB based on data regarding the visitor -->
				<td class="infolbl" width="120">MD5 Hash</td>
				<td class="infodata"><?php echo $IGBUser->GetHash(); ?></td>
			</tr>

		</table>
		<br>
		
				
		<!-- Footer info -->
		<table cellspacing="0" width="550">
			<tr>
				<td></td>
				<td class="igbfooter">[IGBClass v<?php echo CLASS_VER;?> &amp; IGBDemo] writen by
				<?php
					if ($IGBUser->UserServerIP()=="157.157.139.10:26000") {
						echo '<a href="evemailto:nonsequitur" subject="IGBClass v'.CLASS_VER.'" message="" alt="Send an eve-mail">nonsequitur</a>';
					} else {
						echo "nonsequitur";
					}
				?>
				</td>
				<td></td>
			</tr> 
		</table>
				
		</center>
	</body>
</html>

<?php
// back into php again

// now we handle a non TrustEnabled state and show a page and show a message if we need to.
} else {
	// Content for non TrustEnabled viewer.
    echo "<html><head><title>Whoops!</title></head>";
	echo "<body>";
	echo "[ <a href=\"http://".$_SERVER['HTTP_HOST'].$_SERVER['SCRIPT_NAME']."\">Reload</a> ]<br><br>";
    echo "This demo, would not be much of a demo without trust variables.<br>Try reloading the page and answering yes next time.";
	echo "</body></html>";
}

// flush all generated html to the browser and any headers generated above are sent first
ob_end_flush()
?>